
import org.okip.service.dbc.api.Factory;
import org.okip.service.dbc.impl.FactoryImpl;

class TestThread extends Thread {
  org.okip.service.dbc.api.Factory myFactory;

  public TestThread (org.okip.service.dbc.api.Factory factory) {
    myFactory = factory;
  }


  public void run () {
    org.okip.service.dbc.api.Connection connection;

    try {
      connection = myFactory.getConnection("jdbc:postgresql:test", 
					   "org.postgresql.Driver",
					   "corvus",
					   ""); 
      connection.clearWarnings();
    } catch (Exception e) {
      e.printStackTrace();
    }    
  }
}

class PoolTest {
  public static void main(String args[]) {
    org.okip.service.dbc.api.Factory myFactory=null;
      
    TestThread thread[] = new TestThread[15];

    try {
      myFactory = 
	(org.okip.service.dbc.api.Factory) org.okip.service.shared.api.FactoryManager.getFactory("org.okip.service.dbc.api","org.okip.service.dbc.impl", null);
      
      for (int i=0; i<15; i++) {
	thread[i] = new TestThread(myFactory);
      }

      for (int i=0; i<15; i++) {
	thread[i].start();
	//	Thread.sleep(1000);
      }
      
    } catch (Exception e) {
      e.printStackTrace();
    }

  }

}

