package edu.mit.is.service.authorization;

public class PersonsIterator
implements org.okip.service.authorization.api.AgentsIterator{
  protected Rows                rows         =
    null;
  protected Factory factory =
    null;

  /**
   * Method hasNext
   *
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public boolean hasNext()
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != this.rows) {
      return rows.hasMoreRows();
    }

    return false;
  }

  /**
   * Method next
   *
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public org.okip.service.authorization.api.Agent next()
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != this.rows) {
      return getPerson(this.rows.getColumnNames(), this.rows.nextRow());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.AGENTSENUMERATIONFAILED);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param factory
   * @param function
   * @param isActiveNow
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.AgentsIterator getWhoCanDo(
          Factory factory,
          org.okip.service.authorization.api.Function function,
          boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getPeopleInternal(factory, function, null, isActiveNow, true);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param factory
   * @param function
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.AgentsIterator getWhoCanDo(
          Factory factory,
          org.okip.service.authorization.api.Function function,
          org.okip.service.authorization.api.Qualifier qualifier,
          boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getPeopleInternal(factory, function, qualifier, isActiveNow,
                             true);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param factory
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.AgentsIterator getWhoCanDo(
          Factory factory,
          org.okip.service.authorization.api.Qualifier qualifier,
          boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getPeopleInternal(factory, null, qualifier, isActiveNow,
                             true);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param factory
   * @param functionType
   * @param isActiveNow
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.AgentsIterator getWhoCanDo(
          Factory factory,
          org.okip.service.authorization.api.FunctionType functionType,
          boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getPeopleInternal(factory, (String) null,
      ((edu.mit.is.service.authorization.FunctionType)  functionType).getKeyword(), (Object) null,
      (String) null, (String) null,
      isActiveNow
        ? "Y"
        : "N", (String) null);
  }

  /**
   * Method getWhoCanDo
   *
   *
   * @param factory
   * @param functionType
   * @param qualifier
   * @param isActiveNow
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.AgentsIterator getWhoCanDo(
          Factory factory,
          org.okip.service.authorization.api.FunctionType functionType,
          org.okip.service.authorization.api.Qualifier qualifier,
          boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getPeopleInternal(factory, (String) null,
      ((edu.mit.is.service.authorization.FunctionType) functionType).getKeyword(),
      (Object) null,
      (String) qualifier.getKey(),
      ((edu.mit.is.service.authorization.QualifierType) qualifier.getQualifierType()).getKeyword(),
      isActiveNow
        ? "Y"
        : "N", (String) null);
  }

  /**
   * Method getPeopleInternal
   *
   *
   * @param factory
   * @param function
   * @param qualifier
   * @param isActiveNow
   * @param expandQualifiers
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  private static org.okip.service.authorization.api.AgentsIterator getPeopleInternal(
          Factory factory,
          org.okip.service.authorization.api.Function function,
          org.okip.service.authorization.api.Qualifier qualifier,
          boolean isActiveNow,
          boolean expandQualifiers)
  throws org.okip.service.authorization.api.AuthorizationException {
    String                                      functionType    =
      (null == function)
      ? null
      : ((null == function.getFunctionType())
         ? null
         : ((edu.mit.is.service.authorization.FunctionType)
           function.getFunctionType()).getKeyword());
    String                                      functionName        =
      (null == function)
      ? null
      : (String) function.getKey();
    String                                      qualifierType       =
      (null == qualifier)
      ? null
      : ((null == qualifier.getQualifierType())
         ? null
         : ((edu.mit.is.service.authorization.QualifierType)
           qualifier.getQualifierType()).getKeyword());
    String                                      qualifierCode       =
      (null == qualifier)
      ? null
      : (String) qualifier.getKey();
    Object                                      qualifierId         =
      (null == qualifier)
      ? null
      : ((Qualifier) qualifier).getId();
    String                                      expandQualifiersStr =
      (expandQualifiers
         ? "Y"
         : "N");
    String                                      isActiveNowStr      =
      (isActiveNow
         ? "Y"
         : "N");
    edu.mit.is.service.authorization.PersonsIterator people              =
      (edu.mit.is.service.authorization.PersonsIterator)
        getPeopleInternal(factory, functionName,
                        functionType, qualifierId, qualifierCode,
                        qualifierType, isActiveNowStr,
                        expandQualifiersStr);

    if (null == people.rows) {
      if (factory.isFunctionFoundInAuthorization(function)) {
        if (factory.isQualifierFoundInAuthorization(qualifier)) {
          return people;
        }

        throw new org.okip.service.authorization.api.AuthorizationException(
          org.okip.service.authorization.api.AuthorizationException.QUALIFIERNOTFOUNDINAUTHORIZATION);
      }

      throw new org.okip.service.authorization.api.AuthorizationException(
        org.okip.service.authorization.api.AuthorizationException.FUNCTIONNOTFOUNDINAUTHORIZATION);
    }

    return people;
  }

  private static org.okip.service.authorization.api.AgentsIterator getPeopleInternal(
          Factory factory,
          String functionName,
          String functionType,
          Object qualifierId,
          String qualifierCode,
          String qualifierType,
          String isActiveNowStr,
          String expandQualifiersStr)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      String sqlQuery = getPeopleSQL(factory, expandQualifiersStr,
                                     isActiveNowStr, functionType,
                                     functionName, qualifierType,
                                     qualifierCode, qualifierId);

      return getPeople(factory, sqlQuery);
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        new String(
          org.okip.service.authorization.api.AuthorizationException.QUERYAUTHORIZATIONFAILED
          + ex.getMessage()));
    }
  }

  protected static org.okip.service.authorization.api.AgentsIterator getPeople(
          Factory factory,
          String sqlQuery)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if (null != sqlQuery) {
        Connection connection =
          factory.getConnection();
        Table      table      =
          connection.executeQuery(sqlQuery);

        if (null != table) {
          PersonsIterator people =
            new PersonsIterator();

          people.factory = factory;
          people.rows         = table.getRows();

          return people;
        }
      }
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.QUERYAUTHORIZATIONFAILED);
  }

  /**
   * @param algorithm is "WHO_CAN_DO"
   * @param expandQualifiers is either "Y" or "N", default is "N"
   * @param isActiveNow is either "Y" or "N", default is "N"
   */
  private static String getPeopleSQL(
          Factory factory,
          String expandQualifiers, String isActiveNow,
          String functionType, String functionName,
          String qualifierType, String qualifierCode, Object qualifierId)
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != factory) {
      Connection connection =
        factory.getConnection();
      Object[]                                 args       = new Object[11];

      args[0]  = "WHO_CAN_DO";
      args[1]  = (null == expandQualifiers)
                 ? ""
                 : expandQualifiers;
      args[2]  = (null == isActiveNow)
                 ? ""
                 : isActiveNow;
      args[3]  = "";
      args[4]  = (null == functionType)
                 ? ""
                 : functionType;
      args[5]  = (null == functionName)
                 ? ""
                 : functionName;
      args[7]  = (null == qualifierType)
                 ? ""
                 : qualifierType;
      args[8]  = (null == qualifierCode)
                 ? ""
                 : qualifierCode;
      args[9]  = (null == qualifierId)
                 ? ""
                 : qualifierId.toString();
      args[10] = "";

      int[] columnTypes = new int[12];

      columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[11] = java.sql.DatabaseMetaData.procedureColumnOut;

      int[] dataTypes = new int[12];

      dataTypes[0]  = java.sql.Types.VARCHAR;
      dataTypes[1]  = java.sql.Types.VARCHAR;
      dataTypes[2]  = java.sql.Types.VARCHAR;
      dataTypes[3]  = java.sql.Types.VARCHAR;
      dataTypes[4]  = java.sql.Types.VARCHAR;
      dataTypes[5]  = java.sql.Types.VARCHAR;
      dataTypes[6]  = java.sql.Types.VARCHAR;
      dataTypes[7]  = java.sql.Types.VARCHAR;
      dataTypes[8]  = java.sql.Types.VARCHAR;
      dataTypes[9]  = java.sql.Types.VARCHAR;
      dataTypes[10] = java.sql.Types.VARCHAR;
      dataTypes[11] = java.sql.Types.VARCHAR;

      Table tab =
        connection.callProcedure("ROLESAPI_GET_SQL_AUTH1", args, columnTypes,
                                 dataTypes);

      if (null != tab) {
        Rows rows = tab.getRows();

        if (rows.hasMoreRows()) {
          Object[] row = rows.nextRow();
          String   sql = (String) row[0];

          return sql;
        }
      }
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.AGENTSENUMERATIONFAILED);
  }

  private org.okip.service.authorization.api.Agent getPerson(
          String[] columnNames, Object[] row)
  throws org.okip.service.authorization.api.AuthorizationException {
    if ((null != columnNames) && (null != row)) {
      java.util.Properties properties = new java.util.Properties();

      for (int i = 0; columnNames.length != i; i++) {
        properties.put(columnNames[i], row[i]);
      }

      return new Person(factory,
              properties);
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.AGENTSENUMERATIONFAILED);
  }

}
