package edu.mit.is.service.authorization;

public class RowsMetaData {

	protected int columnCount = 0 ;
	public int getColumnCount() { return this.columnCount ; }

	protected ColumnMetaData[] columnsMetaData = null ;
	public ColumnMetaData[] getColumnsMetaData() { return this.columnsMetaData ; }

	protected RowsMetaData( java.sql.ResultSetMetaData rsMeta )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			this.columnCount = rsMeta.getColumnCount() ;
			if( 0 != this.columnCount )
			{
				this.columnsMetaData = new ColumnMetaData[ this.columnCount ] ;
				for( int i = 0 ; this.columnsMetaData.length != i ; i ++ )
				{
					this.columnsMetaData[ i ] = new ColumnMetaData( i + 1 , rsMeta ) ;
				}
			}
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	protected RowsMetaData( ColumnMetaData[] columnsMetaData )
	{
		if( null != columnsMetaData )
		{
			this.columnsMetaData = columnsMetaData ;
			this.columnCount = columnsMetaData.length ;
		}
	}

}