// Copyright 1997 The Open Group Research Institute.  All rights reserved.

package krb4.lib;

import java.io.*;
import java.util.*;

public interface Krb4CredsCache {
	public void init(String cacheType, String cacheName,
		String cname, String cinst, String crealm)
		throws Krb4Exception, IOException, LockException;
	public Krb4Creds read(String sname, String sinst, String srealm)
		throws Krb4Exception, IOException, LockException;
	public void write(Krb4Creds creds)
		throws Krb4Exception, IOException, LockException;
	public void print()
		throws Krb4Exception, IOException, LockException;
	public Enumeration elements()
		throws Krb4Exception, IOException, LockException;
	public void destroy()
		throws Krb4Exception, IOException, LockException;
}
