package org.okip.service;
/**
<p>
MIT OKI&#153; API Implementation License.
</p>
<p>
   Copyright (c) 2002 Massachusetts Institute of Technology
</p>
<p>
   This work, including software, documents, or other related items (the
   "Software"), is being provided by the copyright holder(s) subject to
   the terms of the MIT OKI&#153; API Implementation License. By
   obtaining, using and/or copying this Software, you agree that you have
   read, understand, and will comply with the following terms and
   conditions of the MIT OKI&#153; API Implementation License:
</p>
<p>
   Permission to use, copy, modify, and distribute this Software and its
   documentation, with or without modification, for any purpose and
   without fee or royalty is hereby granted, provided that you include
   the following on ALL copies of the Software or portions thereof,
   including modifications or derivatives, that you make:
</p>
<p>
<ul>
<li>
<p> 
     The full text of the MIT OKI&#153; API Implementation License in a
     location viewable to users of the redistributed or derivative
     work.
</p>
</li>
<li>
<p>
       Any pre-existing intellectual property disclaimers, notices, or
       terms and conditions. If none exist, a short notice similar to the
       following should be used within the body of any redistributed or
       derivative Software:
       "Copyright (c) 2002 Massachusetts Institute of Technology
       All Rights Reserved."
</p>
</li>
<li>
<p>
       Notice of any changes or modifications to the MIT OKI&#153;
       Software, including the date the changes were made. Any modified
       software must be distributed in such as manner as to avoid any
       confusion with the original MIT OKI&#153; Software.
</li>
</ul>
</p>
<p>
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
</p>
<p>
   The name and trademarks of copyright holder(s) and/or MIT may NOT be
   used in advertising or publicity pertaining to the Software without
   specific, written prior permission. Title to copyright in the Software
   and any associated documentation will at all times remain with the
   copyright holders.
<p>
</p>
   The export of software employing encryption technology may require a
   specific license from the United States Government. It is the
   responsibility of any person or organization contemplating export to
   obtain such a license before exporting this Software.
</p>
$Source: /cvs/oki/tech/src/org/okip/service/ApiImplementationLicenseMIT.java,v $
@version $Revision: 1.5 $ / $Date: 2002/03/11 19:30:30 $
*/
public class ApiImplementationLicenseMIT
implements java.io.Serializable {
	public final String toString()
	{
		return
"/**\n"+
"<p>\n"+
"MIT OKI\u2122 API Implementation License.\n"+
"</p>\n"+
"<p>\n"+
"   Copyright (c) 2002 Massachusetts Institute of Technology\n"+
"</p>\n"+
"<p>\n"+
"   This work, including software, documents, or other related items (the\n"+
"   \"Software\"), is being provided by the copyright holder(s) subject to\n"+
"   the terms of the MIT OKI\u2122 API Implementation License. By\n"+
"   obtaining, using and/or copying this Software, you agree that you have\n"+
"   read, understand, and will comply with the following terms and\n"+
"   conditions of the MIT OKI\u2122 API Implementation License:\n"+
"</p>\n"+
"<p>\n"+
"   Permission to use, copy, modify, and distribute this Software and its\n"+
"   documentation, with or without modification, for any purpose and\n"+
"   without fee or royalty is hereby granted, provided that you include\n"+
"   the following on ALL copies of the Software or portions thereof,\n"+
"   including modifications or derivatives, that you make:\n"+
"</p>\n"+
"<p>\n"+
"<ul>\n"+
"<li>\n"+
"<p> \n"+
"     The full text of the MIT OKI\u2122 API Implementation License in a\n"+
"     location viewable to users of the redistributed or derivative\n"+
"     work.\n"+
"</p>\n"+
"</li>\n"+
"<li>\n"+
"<p>\n"+
"       Any pre-existing intellectual property disclaimers, notices, or\n"+
"       terms and conditions. If none exist, a short notice similar to the\n"+
"       following should be used within the body of any redistributed or\n"+
"       derivative Software:\n"+
"       \"Copyright (c) 2002 <em>&lt;copyright holder&gt;</em>.\n"+
"       All Rights Reserved.\"\n"+
"</p>\n"+
"</li>\n"+
"<li>\n"+
"<p>\n"+
"       Notice of any changes or modifications to the MIT OKI\u2122\n"+
"       Software, including the date the changes were made. Any modified\n"+
"       software must be distributed in such as manner as to avoid any\n"+
"       confusion with the original MIT OKI\u2122 Software.\n"+
"</li>\n"+
"</ul>\n"+
"</p>\n"+
"<p>\n"+
"   THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\n"+
"   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\n"+
"   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.\n"+
"   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY\n"+
"   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,\n"+
"   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE\n"+
"   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n"+
"</p>\n"+
"<p>\n"+
"   The name and trademarks of copyright holder(s) and/or MIT may NOT be\n"+
"   used in advertising or publicity pertaining to the Software without\n"+
"   specific, written prior permission. Title to copyright in the Software\n"+
"   and any associated documentation will at all times remain with the\n"+
"   copyright holders.\n"+
"<p>\n"+
"</p>\n"+
"   The export of software employing encryption technology may require a\n"+
"   specific license from the United States Government. It is the\n"+
"   responsibility of any person or organization contemplating export to\n"+
"   obtain such a license before exporting this Software.\n"+
"</p>\n"+
"$Source: /cvs/oki/tech/src/org/okip/service/ApiImplementationLicenseMIT.java,v $\n"+
"@version@ $Revision: 1.5 $\n"+
"$Date: 2002/03/11 19:30:30 $\n"+
"*/";
	}
}

