package org.okip.service.dbc.impl;

import org.okip.service.dbc.api.DbcException;


/**
 * Class SavepointImpl
 *
 *
 * @author
 * @version $Revision: 1.2 $, $Date: 2002/05/13 20:42:06 $
 */
public class SavepointImpl
implements org.okip.service.dbc.api.Savepoint, java.io.Serializable {

  private transient java.sql.Savepoint delegate;

	public SavepointImpl( java.sql.Savepoint delegate ) {
			this.delegate = delegate;
	}

	protected final java.sql.Savepoint getDelegate() {
			return delegate;
	}

  /**
   * Method getSavepointId
   *
   *
   * @return int
   *
   * @throws DbcException
   *
   */
  public int getSavepointId()
  throws DbcException {
    try {
      return delegate.getSavepointId();
    } catch ( java.sql.SQLException sqle ) {
          throw ConnectionImpl.chainException("", sqle);
    }
	}

  /**
   * Method getSavepointName
   *
   *
   * @return String
   *
   * @throws DbcException
   *
   */
  public String getSavepointName()
  throws DbcException {
    try {
      return delegate.getSavepointName();
    } catch ( java.sql.SQLException sqle ) {
          throw ConnectionImpl.chainException("", sqle);
    }
	}
}
