package org.okip.service.logging.api;



/** Priority is the abstraction used to represent warning levels for the 
 *  service as well as individual messages. An arbitrary number of levels 
 * may exist in a system. It is the responsibility of the implementation 
 * to write an appropriate comparator function to determine the entries 
 * that get logged.
*/

public interface Priority
extends java.io.Serializable {

  /**
   * Method getLevel
   *
   * @return int level
   */
  public int getLevel();
}
