package org.okip.service.usermessaging.api;

// Interface UserMessage 
// Notes: the Agent is assumed to be the originator of the message. Message is 
// assumed to have a Type (that may be application dependent), a Header, and a 
// Body. 
public interface UserMessage
extends java.io.Serializable {
	public Object getHeader();
	public Object getBody();
	public String getMessageMediaType();
	public UserMessageDeliveryType getMessageDeliveryType ();
	public org.okip.service.shared.api.Agent getAgent();
};
