package org.okip.service.workflow.api;

import org.okip.service.shared.api.*;

public interface GroupingExpression 
extends Expression
{
	/* All children need to grouped with the same logical conjuction
		 so they can be evaluated as a group */

  public boolean hasORConjunction();

  public boolean hasANDConjunction();

  public void setORConjunction();

  public void setANDConjunction();

  public void addChild(Expression child);

  public void removeChild(Expression child);

  public Expression[] getChildren();

}
