package org.okip.service.workflow.api;

import org.okip.service.shared.api.*;
import org.okip.service.locallyuniqueidentifier.api.*;

public interface ModelStep 
extends java.io.Serializable
{
	public LocallyUniqueIdentifier getIdentifier();

	public String getName();
	public void setName(String name);

	public String getDescription();
	public void setDescription(String description);

	public Role getRole();
	public void setRole(Role role);
     
	public ModelStep[] getParents(); 
	public ModelStep[] getChildren();

	public void addChild(ModelStep modelStep);
	public void removeChild(ModelStep modelStep);

	public ReferentialExpression getRootExpression();
	public void setRootExpression(ReferentialExpression referentialExpression);

	public ModelWorkflow getModelWorkflow();
}
