package org.okip.service.workflow.api;

import org.okip.service.shared.api.*;
import org.okip.service.locallyuniqueidentifier.api.*;


public interface Workflow /* instance */
extends java.io.Serializable
{

	public void abort();

	public void submitStatus(OutputState outputState);

	public Step getCurrentStep();

	public Step[] getPossibleSteps();

	public void changeStep(Step step);

	public WorkHistoryRecord[] getWorkHistory();

	public Batch getBatch();

	public Qualifier getQualifier();

}
