package org.okip.service.workflow.api;

import org.okip.service.shared.api.*;
import org.okip.service.locallyuniqueidentifier.api.*;

public interface WorkflowDefinition
extends java.io.Serializable
{
	/* Design Time */
		public LocallyUniqueIdentifier getIdentifier();
    public String getName();
    public String  getDescription();
    public void setName(String name);
    public void setDescription(String description);

    public Model getModel();
    public Step getInitialStep();
    public void setInitialStep (Step step);
    public QualifierType getQualifierType();
    public void setQualifierType(QualifierType qualifierType);
}


