package edu.mit.is.service.authorization;

public class Table
implements java.io.Serializable {

	private Connection connection = null ;
	public Connection getConnection()
	{
		return this.connection ;
	}

	private Rows rows = null ;
	public Rows getRows()
	{
		if( null != this.rows )
		{
			return ( Rows ) ( ( ( Rows ) this.rows ).clone() ) ;
		}
		return null ;
	}

	public static Table getTables
		( Connection connection
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		String[] tableTypes = new String[ 2 ] ;
		tableTypes[ 0 ] = "TABLE" ;
		tableTypes[ 1 ] = "VIEW" ;
		return getTables
			( connection
			, null
			, null
			, null
			, tableTypes
			) ;
	}

	public static Table getTables
		( Connection connection
		, String catalog
		, String schemaPattern
		, String tableNamePattern
		, String[] tableTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return new Table
			( connection
			, catalog
			, schemaPattern
			, tableNamePattern
			, tableTypes
			) ;
	}

	public static Table executeQuery
		( Connection connection
		, String sql
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Table table
			= new Table
				( connection
				, sql
				, ( Object[] ) null
				, ( int[] ) null
				, ( int[] ) null
				) ;
		return table ;
	}

	public static Table executeQuery
		( Connection connection
		, String sql
		, Object[] objs
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Table table
			= new Table
				( connection
				, sql
				, objs
				, ( int[] ) null
				, ( int[] ) null
				) ;
		return table ;
	}

	public static Table executeQuery
		( Connection connection
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Table table
			= new Table
				( connection
				, sql
				, objs
				, targetSqlTypes
				, ( int[] ) null
				) ;
		return table ;
	}

	public static Table executeQuery
		( Connection connection
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Table table
			= new Table
				( connection
				, sql
				, objs
				, targetSqlTypes
				, scales
				) ;
		return table ;
	}

	public static Table getProcedureColumns
		( Connection connection
		, String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Table table
			= new Table
				( connection
				, catalog
				, schemaPattern
				, procedureName
				, columnNamePattern
				) ;
		return table ;
	}

	public static Table getProcedures
		( Connection connection
		, String catalog
		, String schemaPattern
		, String procedureNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Table table
			= new Table
				( connection
				, catalog
				, schemaPattern
				, procedureNamePattern
				) ;
		return table ;
	}

	protected Table
		( Connection connection
		, Rows rows
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.connection = connection ;
		this.rows = rows ;
	}

	private Table
		( Connection connection
		, String catalog
		, String schemaNamePattern
		, String tableNamePattern
		, String[] tableTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.connection = connection ;
		this.rows
			= new Rows
				( this
				, catalog
				, schemaNamePattern
				, tableNamePattern
				, tableTypes
				) ;
	}

	private Table
		( Connection connection
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.connection = connection ;
		this.rows
			= new Rows
				( this
				, sql
				, objs
				, targetSqlTypes
				, scales
				) ;
	}

	private Table
		( Connection connection
		, String catalog
		, String schemaPattern
		, String procedureNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.connection = connection ;
		this.rows
			= new Rows
				( this
				, catalog
				, schemaPattern
				, procedureNamePattern
				) ;
	}

	private Table
		( Connection connection
		, String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.connection = connection ;
		this.rows
			= new Rows
				( this
				, catalog
				, schemaPattern
				, procedureName
				, columnNamePattern
				) ;
	}

}