package edu.mit.is.util.romi;

public interface Remote
extends java.rmi.Remote {

  /**
   * Method authenticate
   *
   *
   * @param ticket
   *
   * @return boolean
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */
  boolean authenticate(byte[] ticket)
  throws java.rmi.RemoteException;

  /**
   * Method invoke
   *
   *
   * @param obj
   * @param methodName
   * @param types
   * @param args
   *
   * @return Object
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */
  Object invoke(java.io.Serializable obj, String methodName, Class[] types,
                Object[] args)
  throws java.rmi.RemoteException;

  /**
   * Method test
   *
   *
   * @return String
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */
  String test()
  throws java.rmi.RemoteException;
}
