package edu.mit.is.util.romi.client;

public class Factory
implements org.okip.util.romi.client.api.Factory {

  /**
   * Method createClient
   *
   *
   * @param host
   * @param port
   * @param service
   * @param server
   *
   * @return org.okip.util.romi.client.api.Client
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */
  public org.okip.util.romi.client.api.Client createClient(String host,
          int port, String server)
  throws org.okip.util.romi.client.api.ClientException {
    return Client.create(this, host, port, server);
  }

  private org.okip.service.shared.api.Agent             owner     = null;

  /**
   * Return owner of this Factory.
   *
   *
   * @return org.okip.service.shared.api.Agent Owner
   *
   */
  public org.okip.service.shared.api.Agent getOwner() {
    return this.owner;
  }

  /**
   * Set the owner of this Factory.
   *
   *
   * @param Agent Owner
   *
   */
  public void setOwner(org.okip.service.shared.api.Agent owner) {
    if(null == owner.getProxy(edu.mit.is.util.romi.RomiAgent.class)) {
      owner.addProxy((org.okip.service.shared.api.Agent)
        new edu.mit.is.util.romi.RomiAgent(null,null));
    }
    this.owner = owner;
  }
}
