package org.okip.service.dbc.impl;

import org.okip.service.dbc.api.DbcException; 

import org.okip.service.dbc.api.Array; 

public class ArrayImpl implements org.okip.service.dbc.api.Array,
	java.io.Serializable { 
  
  private transient java.sql.Array delegate; 

	public ArrayImpl( java.sql.Array delegate ) {
		this.delegate = delegate;
	}

  public Object getArray() 
  throws DbcException {
		 try {
			return delegate.getArray();
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
  }

  public Object getArray(long index, int count) 
  throws DbcException {
		try {
			return delegate.getArray(index,count);
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
	}

  public Object getArray(long index, int count, java.util.Map map) 
  throws DbcException {
		try {
			return delegate.getArray(index,count,map);
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

  public Object getArray(java.util.Map map) 
  throws DbcException {
		try {
			return delegate.getArray(map);
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

  public int getBaseType() 
  throws DbcException {
		try {
			return delegate.getBaseType();
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

  public String getBaseTypeName() 
  throws DbcException {
		try {
			return delegate.getBaseTypeName();
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

  public org.okip.service.dbc.api.ResultSet getResultSet() 
  throws DbcException {
		try {
			return new ResultSetImpl(delegate.getResultSet(), null);
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

  public org.okip.service.dbc.api.ResultSet getResultSet(long index, int count) 
  throws DbcException {
		try {
			return new ResultSetImpl( delegate.getResultSet(index,count), null );
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

  public org.okip.service.dbc.api.ResultSet getResultSet(long index, int count, java.util.Map map) 
  throws DbcException {
		try {
			return new ResultSetImpl( delegate.getResultSet(index,count,map), null );
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

  public org.okip.service.dbc.api.ResultSet getResultSet(java.util.Map map) 
  throws DbcException {
		try {
			return new ResultSetImpl( delegate.getResultSet(map), null );
		} catch( java.sql.SQLException e ) {
			throw ConnectionImpl.chainException("",e);
		}
  }

	protected final java.sql.Array getDelegate() {
			return delegate;
	}
}
