package org.okip.service.dbc.impl;

import  org.okip.service.dbc.api.DbcException;

public class RowSetImpl extends ResultSetImpl
implements org.okip.service.dbc.api.RowSet, java.io.Serializable {   

	private transient javax.sql.RowSet delegate;
	private org.okip.service.dbc.api.Statement parent;

	public RowSetImpl( javax.sql.RowSet delegate, org.okip.service.dbc.api.Statement parent ) {
			super(delegate, parent);
	}

  public void clearParameters()  throws DbcException {
		try {
			delegate.clearParameters();
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
 }

  public void execute()  throws DbcException {
		try {
			delegate.execute();
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
 }

  //public String getCommand()  throws DbcException {
  public String getCommand() {
		return delegate.getCommand();
  }

  //public String getDataSourceName()  throws DbcException {
  public String getDataSourceName() {
		return delegate.getDataSourceName();
  }

  public boolean getEscapeProcessing()  throws DbcException {
	 try {
			return delegate.getEscapeProcessing();
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public int getMaxFieldSize()  throws DbcException {
	 try {
			return delegate.getMaxFieldSize();
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public int getMaxRows()  throws DbcException {
	 try {
			return delegate.getMaxRows();
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public String getPassword() {
		return delegate.getPassword();
  }

  public int getQueryTimeout()  throws DbcException {
		 try {
				return delegate.getQueryTimeout();
			} catch( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
			}
  }

  public int getTransactionIsolation()  throws DbcException {
			return delegate.getTransactionIsolation();
  }

  public java.util.Map getTypeMap()  throws DbcException {
		 try {
			return delegate.getTypeMap();
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public String getUrl()  throws DbcException {
	 try {
			return delegate.getUrl();
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public String getUsername()  throws DbcException {
		return delegate.getUsername();
  }

  public boolean isReadOnly() {
		return delegate.isReadOnly();
  }

  public void setArray(int parameterIndex, org.okip.service.dbc.api.Array x)  throws DbcException {
		try {
			delegate.setArray(parameterIndex, ((ArrayImpl)x).getDelegate());
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setBigDecimal(int parameterIndex, java.math.BigDecimal x)  throws DbcException {
	try {
		delegate.setBigDecimal(parameterIndex, x);
	} catch( java.sql.SQLException sqle ) {
			throw ConnectionImpl.chainException("", sqle);
	}
 }

  public void setBlob(int parameterIndex, org.okip.service.dbc.api.Blob x)  throws DbcException {
		try {
			delegate.setBlob(parameterIndex, ((BlobImpl)x).getDelegate() );
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
 }

  public void setBoolean(int parameterIndex, boolean x)  throws DbcException {
		try {
			delegate.setBoolean(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setByte(int parameterIndex, byte x)  throws DbcException {
	try {
			delegate.setByte(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
	}

  public void setBytes(int parameterIndex, byte[] x)  throws DbcException {
		try {
			delegate.setBytes(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setClob(int parameterIndex, org.okip.service.dbc.api.Clob x)  throws DbcException {
		try {
			delegate.setClob(parameterIndex, ( ((ClobImpl)x).getDelegate()) );
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setCommand(String cmd) throws DbcException {
		try {
			delegate.setCommand(cmd);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setConcurrency(int concurrency)  throws DbcException {
		try {
			delegate.setConcurrency(concurrency);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setDataSourceName(String name)  throws DbcException {
		try {
			delegate.setDataSourceName(name);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setDate(int parameterIndex, java.sql.Date x) throws DbcException {
		try {
			delegate.setDate(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setDate(int parameterIndex, java.sql.Date x, java.util.Calendar cal)  throws DbcException {
		try {
			delegate.setDate(parameterIndex, x, cal);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setDouble(int parameterIndex, double x)  throws DbcException {
		try {
			delegate.setDouble(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setEscapeProcessing(boolean enable)  throws DbcException {
		try {
			delegate.setEscapeProcessing(enable);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setFloat(int parameterIndex, float x)  throws DbcException {
		try {
			delegate.setFloat(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setInt(int parameterIndex, int x)  throws DbcException {
		try {
			delegate.setInt(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setLong(int parameterIndex, long x)  throws DbcException {
		try {
			delegate.setLong(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setMaxFieldSize(int max) throws DbcException {
		try {
			delegate.setMaxFieldSize(max);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setMaxRows(int max)  throws DbcException {
		try {
			delegate.setMaxRows(max);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setNull(int parameterIndex, int sqlType)  throws DbcException {
		try {
			delegate.setNull(parameterIndex, sqlType);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setNull(int paramIndex, int sqlType, String typeName)  throws DbcException {
		try {
			delegate.setNull(paramIndex, sqlType, typeName);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setObject(int parameterIndex, Object x)  throws DbcException {
		try {
			delegate.setObject(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setObject(int parameterIndex, Object x, int targetSqlType)  throws DbcException {
		try {
			delegate.setObject(parameterIndex, x, targetSqlType);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setObject(int parameterIndex, Object x, int targetSqlType, int scale)  throws DbcException {
		try {
			delegate.setObject(parameterIndex, x, targetSqlType, scale);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setPassword(String password)  throws DbcException {
		try {
			delegate.setPassword(password);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setQueryTimeout(int seconds)  throws DbcException {
		try {
			delegate.setQueryTimeout(seconds);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setReadOnly(boolean value)  throws DbcException {
		try {
			delegate.setReadOnly(value);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setRef(int parameterIndex, java.sql.Ref x)  throws DbcException {
		try {
			delegate.setRef(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setShort(int parameterIndex, short x)  throws DbcException {
		try {
			delegate.setShort(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setString(int parameterIndex, String x)  throws DbcException {
		try {
			delegate.setString(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setTime(int parameterIndex, java.sql.Time x)  throws DbcException {
		try {
			delegate.setTime(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setTime(int parameterIndex, java.sql.Time x, java.util.Calendar cal)  throws DbcException {
		try {
			delegate.setTime(parameterIndex, x, cal);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setTimestamp(int parameterIndex, java.sql.Timestamp x)  throws DbcException {
		try {
			delegate.setTimestamp(parameterIndex, x);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setTimestamp(int parameterIndex, java.sql.Timestamp x, java.util.Calendar cal)  throws DbcException {
		try {
			delegate.setTimestamp(parameterIndex, x, cal);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setTransactionIsolation(int level)  throws DbcException {
		try {
			delegate.setTransactionIsolation(level);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setType(int type)  throws DbcException {
		try {
			delegate.setType(type);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setTypeMap(java.util.Map typeMap)  throws DbcException {
		try {
			delegate.setTypeMap(typeMap);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setUrl(String url)  throws DbcException {
		try {
			delegate.setUrl(url);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

  public void setUsername(String name)  throws DbcException {
		try {
			delegate.setUsername(name);
		} catch( java.sql.SQLException sqle ) {
				throw ConnectionImpl.chainException("", sqle);
		}
  }

}
