package org.okip.service.logging.api;


/**
Interface FormatSpecification
Purpose: Abstracts the formatting strategy used for the message.
*/

public interface FormatSpecification
extends java.io.Serializable {

  /**
   * Method format
   * Formats input String in format specified
   *
   * @param message Input message, possibly with formatting directives.
   *
   * @return Formatted String
   *
   */

  public String format(final String message);
}
