package org.okip.service.usermessaging.api;

import  org.okip.service.shared.api.Agent;

//Interface UserMessagingService
public interface UserMessagingService
{
public void subscribe(Agent me);
public void subscribe(Agent me, UserMessageTopic topic);
public void subscribe(Agent me, UserMessageTopic[] topics);

public void unsubscribe(Agent me, UserMessageTopic topic);
public void unsubscribe(Agent me);
public void unsubscribe(Agent me, UserMessageTopic[] topics );

public Boolean send(Agent me, Agent[] ye, UserMessageTopic topic,
										UserMessage msg );
public Boolean send( org.okip.service.shared.api.Agent me, 
										 org.okip.service.shared.api.Agent ye,
										 UserMessageTopic topic, UserMessage msg );
public Boolean send( org.okip.service.shared.api.Agent me, 
										 org.okip.service.shared.api.Agent ye,
										 UserMessage msg );

public Boolean send(Agent me, Agent[] you, UserMessageTopic topic, UserMessage[] messages
   );

public Boolean send( org.okip.service.shared.api.Agent me, 
										 org.okip.service.shared.api.Agent ye,
										 UserMessageTopic topic, UserMessage[] messages );

public Boolean send( org.okip.service.shared.api.Agent me, 
										 org.okip.service.shared.api.Agent ye,
											UserMessage[] messages );

public UserMessage[] receive(Agent me, UserMessageTopic topic );
public UserMessage[] receive(Agent me);
};
